<?php

require_once(sfConfig::get('sf_lib_dir').'/filter/base/BaseFormFilterPropel.class.php');

/**
 * ShoutboxMessages filter form base class.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BaseShoutboxMessagesFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'users_list'  => new sfWidgetFormFilterInput(),
      'groups_list' => new sfWidgetFormFilterInput(),
      'sender_id'   => new sfWidgetFormFilterInput(),
      'created_at'  => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'send_at'     => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'title'       => new sfWidgetFormFilterInput(),
      'message'     => new sfWidgetFormFilterInput(),
      'att_title'   => new sfWidgetFormFilterInput(),
      'att_file'    => new sfWidgetFormFilterInput(),
      'status'      => new sfWidgetFormFilterInput(),
    ));

    $this->setValidators(array(
      'users_list'  => new sfValidatorPass(array('required' => false)),
      'groups_list' => new sfValidatorPass(array('required' => false)),
      'sender_id'   => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'created_at'  => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'send_at'     => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'title'       => new sfValidatorPass(array('required' => false)),
      'message'     => new sfValidatorPass(array('required' => false)),
      'att_title'   => new sfValidatorPass(array('required' => false)),
      'att_file'    => new sfValidatorPass(array('required' => false)),
      'status'      => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
    ));

    $this->widgetSchema->setNameFormat('shoutbox_messages_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'ShoutboxMessages';
  }

  public function getFields()
  {
    return array(
      'id'          => 'Number',
      'users_list'  => 'Text',
      'groups_list' => 'Text',
      'sender_id'   => 'Number',
      'created_at'  => 'Date',
      'send_at'     => 'Date',
      'title'       => 'Text',
      'message'     => 'Text',
      'att_title'   => 'Text',
      'att_file'    => 'Text',
      'status'      => 'Number',
    );
  }
}
