<?php

/**
 * ShoutboxMessages form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class ShoutboxMessagesForm extends BaseShoutboxMessagesForm
{

    public function configure()
    {
        // parent::setup();

        $this->setWidgets(array(
            'id'            => new sfWidgetFormInputHidden(),
            'users_list'    => new sfWidgetFormInputHidden(),
            'uzytkownicy'   => new sfWidgetFormPropelChoiceMany(array('model' => 'sfGuardUser'), array('class' => 'required','style' => 'width: 458px;')),
            'groups_list'   => new sfWidgetFormInputHidden(),
            'grupy'         => new sfWidgetFormPropelChoiceMany(array('model' => 'sfGuardGroup'), array('class' => 'required','style' => 'width: 458px;')),
            'sender_id'     => new sfWidgetFormInputHidden(),
            'created_at'    => new sfWidgetFormInputHidden(),
            'send_at'       => new sfWidgetFormInputHidden(),
            'title'         => new sfWidgetFormInput(array(), array('class' => 'required','style' => 'width: 450px;')),
            'message'       => new sfWidgetFormTextareaTinyMCE(array(
                'config'    => '
			language: "pl",
			width: "458",
  			theme_advanced_buttons1 : "bold,italic,underline,separator,strikethrough,justifyleft,justifycenter,justifyright,justifyfull,bullist,numlist,undo,redo,",
			theme_advanced_buttons2 : "",
			theme_advanced_buttons3 : "",
			theme_advanced_toolbar_location : "top",
			theme_advanced_toolbar_align : "left",
			theme_advanced_statusbar_location : "bottom",
  			theme : "advanced",
  			theme_advanced_resizing : false,
			debug: false
        ',),
                array(
                    'class' => 'tiny_mce'
            )),
         //   'att_title' => new sfWidgetFormInput(array(), array('style' => 'width: 450px;')),
         //   'att_file'  => new sfWidgetFormInputFile(array(), array('style' => 'width: 450px;')),
            'status'    => new sfWidgetFormInputHidden(),
        ));

        $this->setValidators(array(
            'id'            => new sfValidatorPropelChoice(array('model' => 'ShoutboxMessages', 'column' => 'id', 'required' => false)),
            'users_list'    => new sfValidatorString(array('max_length' => 255, 'required' => false)),
            'uzytkownicy'   => new sfValidatorPropelChoiceMany(array('model' => 'sfGuardUser', 'required' => false)),
            'groups_list'   => new sfValidatorString(array('max_length' => 255, 'required' => false)),
            'grupy'         => new sfValidatorPropelChoiceMany(array('model' => 'sfGuardGroup', 'required' => false)),
            'sender_id'     => new sfValidatorInteger(array('required' => false)),
            'created_at'    => new sfValidatorDate(array('required' => false)),
            'send_at'       => new sfValidatorDate(array('required' => false)),
            'title'         => new sfValidatorString(array('max_length' => 45, 'required' => false)),
            'message'       => new sfValidatorString(array('required' => true)),
         //   'att_title'     => new sfValidatorString(array('max_length' => 45, 'required' => false)),
         //   'att_file'      => new sfValidatorString(array('max_length' => 45, 'required' => false)),
            'status'        => new sfValidatorInteger(array('required' => false)),
        ));

        $this->widgetSchema->setLabels(array(
            'uzytkownicy' => 'Użytkownicy',
            'grupy' => 'Grupy użytkowników',
            'title' => 'Tytuł',
            'message' => 'Treść',
        //    'att_title' => 'Nazwa załącznika',
        //    'att_file' => 'Plik załącznika',
        ));

        $this->widgetSchema->setHelps(array(
            'uzytkownicy' => 'Zaznacz indywidualnych odbiorców wiadomości. Aby zaznaczyć wielu użytkowników przytrzymaj klawisz <b>Ctrl</b> podczas zaznaczania.',
            'grupy' => 'Zaznacz grupy odbiorców wiadomości. Aby zaznaczyć wiele grup przytrzymaj klawisz <b>Ctrl</b> podczas zaznaczania.',
        ));

        $this->widgetSchema->setNameFormat('shoutbox_messages[%s]');
        $this->validatorSchema->setPostValidator(
            new sfValidatorCallback(array('callback' => array($this, 'checkRecipient')))
        );
        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
    }

    public function checkRecipient($validator, $values)
    {
        if(!isset($values['uzytkownicy']) && !isset($values['grupy']))
        {

            // password is not correct, throw an error
            throw new sfValidatorError($validator, 'Brak adresata');
        }

        // password is correct, return the clean values
        return $values;
    }

}
