<?php


abstract class BaseShoutboxMessages extends BaseObject  implements Persistent {


  const PEER = 'ShoutboxMessagesPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $users_list;

	
	protected $groups_list;

	
	protected $sender_id;

	
	protected $created_at;

	
	protected $send_at;

	
	protected $title;

	
	protected $message;

	
	protected $att_title;

	
	protected $att_file;

	
	protected $status;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getUsersList()
	{
		return $this->users_list;
	}

	
	public function getGroupsList()
	{
		return $this->groups_list;
	}

	
	public function getSenderId()
	{
		return $this->sender_id;
	}

	
	public function getCreatedAt($format = 'Y-m-d')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getSendAt($format = 'Y-m-d')
	{
		if ($this->send_at === null) {
			return null;
		}


		if ($this->send_at === '0000-00-00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->send_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->send_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getTitle()
	{
		return $this->title;
	}

	
	public function getMessage()
	{
		return $this->message;
	}

	
	public function getAttTitle()
	{
		return $this->att_title;
	}

	
	public function getAttFile()
	{
		return $this->att_file;
	}

	
	public function getStatus()
	{
		return $this->status;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::ID;
		}

		return $this;
	} 
	
	public function setUsersList($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->users_list !== $v) {
			$this->users_list = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::USERS_LIST;
		}

		return $this;
	} 
	
	public function setGroupsList($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->groups_list !== $v) {
			$this->groups_list = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::GROUPS_LIST;
		}

		return $this;
	} 
	
	public function setSenderId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->sender_id !== $v) {
			$this->sender_id = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::SENDER_ID;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = ShoutboxMessagesPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setSendAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->send_at !== null || $dt !== null ) {
			
			$currNorm = ($this->send_at !== null && $tmpDt = new DateTime($this->send_at)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->send_at = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = ShoutboxMessagesPeer::SEND_AT;
			}
		} 
		return $this;
	} 
	
	public function setTitle($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->title !== $v) {
			$this->title = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::TITLE;
		}

		return $this;
	} 
	
	public function setMessage($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->message !== $v) {
			$this->message = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::MESSAGE;
		}

		return $this;
	} 
	
	public function setAttTitle($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->att_title !== $v) {
			$this->att_title = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::ATT_TITLE;
		}

		return $this;
	} 
	
	public function setAttFile($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->att_file !== $v) {
			$this->att_file = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::ATT_FILE;
		}

		return $this;
	} 
	
	public function setStatus($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->status !== $v) {
			$this->status = $v;
			$this->modifiedColumns[] = ShoutboxMessagesPeer::STATUS;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->users_list = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->groups_list = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->sender_id = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->created_at = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->send_at = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->title = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->message = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->att_title = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->att_file = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->status = ($row[$startcol + 10] !== null) ? (int) $row[$startcol + 10] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 11; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ShoutboxMessages object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ShoutboxMessagesPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = ShoutboxMessagesPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ShoutboxMessagesPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			ShoutboxMessagesPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(ShoutboxMessagesPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ShoutboxMessagesPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			ShoutboxMessagesPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = ShoutboxMessagesPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ShoutboxMessagesPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ShoutboxMessagesPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = ShoutboxMessagesPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ShoutboxMessagesPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUsersList();
				break;
			case 2:
				return $this->getGroupsList();
				break;
			case 3:
				return $this->getSenderId();
				break;
			case 4:
				return $this->getCreatedAt();
				break;
			case 5:
				return $this->getSendAt();
				break;
			case 6:
				return $this->getTitle();
				break;
			case 7:
				return $this->getMessage();
				break;
			case 8:
				return $this->getAttTitle();
				break;
			case 9:
				return $this->getAttFile();
				break;
			case 10:
				return $this->getStatus();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = ShoutboxMessagesPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUsersList(),
			$keys[2] => $this->getGroupsList(),
			$keys[3] => $this->getSenderId(),
			$keys[4] => $this->getCreatedAt(),
			$keys[5] => $this->getSendAt(),
			$keys[6] => $this->getTitle(),
			$keys[7] => $this->getMessage(),
			$keys[8] => $this->getAttTitle(),
			$keys[9] => $this->getAttFile(),
			$keys[10] => $this->getStatus(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ShoutboxMessagesPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUsersList($value);
				break;
			case 2:
				$this->setGroupsList($value);
				break;
			case 3:
				$this->setSenderId($value);
				break;
			case 4:
				$this->setCreatedAt($value);
				break;
			case 5:
				$this->setSendAt($value);
				break;
			case 6:
				$this->setTitle($value);
				break;
			case 7:
				$this->setMessage($value);
				break;
			case 8:
				$this->setAttTitle($value);
				break;
			case 9:
				$this->setAttFile($value);
				break;
			case 10:
				$this->setStatus($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ShoutboxMessagesPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUsersList($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setGroupsList($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setSenderId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setCreatedAt($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setSendAt($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTitle($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setMessage($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setAttTitle($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setAttFile($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setStatus($arr[$keys[10]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ShoutboxMessagesPeer::DATABASE_NAME);

		if ($this->isColumnModified(ShoutboxMessagesPeer::ID)) $criteria->add(ShoutboxMessagesPeer::ID, $this->id);
		if ($this->isColumnModified(ShoutboxMessagesPeer::USERS_LIST)) $criteria->add(ShoutboxMessagesPeer::USERS_LIST, $this->users_list);
		if ($this->isColumnModified(ShoutboxMessagesPeer::GROUPS_LIST)) $criteria->add(ShoutboxMessagesPeer::GROUPS_LIST, $this->groups_list);
		if ($this->isColumnModified(ShoutboxMessagesPeer::SENDER_ID)) $criteria->add(ShoutboxMessagesPeer::SENDER_ID, $this->sender_id);
		if ($this->isColumnModified(ShoutboxMessagesPeer::CREATED_AT)) $criteria->add(ShoutboxMessagesPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(ShoutboxMessagesPeer::SEND_AT)) $criteria->add(ShoutboxMessagesPeer::SEND_AT, $this->send_at);
		if ($this->isColumnModified(ShoutboxMessagesPeer::TITLE)) $criteria->add(ShoutboxMessagesPeer::TITLE, $this->title);
		if ($this->isColumnModified(ShoutboxMessagesPeer::MESSAGE)) $criteria->add(ShoutboxMessagesPeer::MESSAGE, $this->message);
		if ($this->isColumnModified(ShoutboxMessagesPeer::ATT_TITLE)) $criteria->add(ShoutboxMessagesPeer::ATT_TITLE, $this->att_title);
		if ($this->isColumnModified(ShoutboxMessagesPeer::ATT_FILE)) $criteria->add(ShoutboxMessagesPeer::ATT_FILE, $this->att_file);
		if ($this->isColumnModified(ShoutboxMessagesPeer::STATUS)) $criteria->add(ShoutboxMessagesPeer::STATUS, $this->status);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ShoutboxMessagesPeer::DATABASE_NAME);

		$criteria->add(ShoutboxMessagesPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUsersList($this->users_list);

		$copyObj->setGroupsList($this->groups_list);

		$copyObj->setSenderId($this->sender_id);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setSendAt($this->send_at);

		$copyObj->setTitle($this->title);

		$copyObj->setMessage($this->message);

		$copyObj->setAttTitle($this->att_title);

		$copyObj->setAttFile($this->att_file);

		$copyObj->setStatus($this->status);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ShoutboxMessagesPeer();
		}
		return self::$peer;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
	}

} 